# Table of Contents

- [Introduction](intro.md)
- [Installation](installation.md)
- [Quickstart](quickstart.md)
- [Translator](c2rust-transpile/README.md):
    - [Known limitations](docs/known-limitations.md)
    - [Bitfield Support Crate](c2rust-bitfields/README.md)
<!--
- [Refactoring Tool](c2rust-refactor/README.md)
    - [Commands](c2rust-refactor/commands.md)
    - [Lua Scripting API](c2rust-refactor/doc/scripting_api.html)
    - [`rewrite_expr` tutorial](c2rust-refactor/rewrite.md)
    - [Marks tutorial](c2rust-refactor/select.md)
    - [Ownership analysis](c2rust-refactor/src/analysis/ownership/README.md)
-->
- [Examples](examples/README.md):
    - [json-c](examples/json-c/README.md)
    - [urlparser](examples/urlparser/README.md)
    - [qsort](examples/qsort/README.md)
    - [tmux](examples/tmux/README.md)
    - [grabc](examples/grabc/README.md)
    - [libxml2](examples/libxml2/README.md)
    - [snudown](examples/snudown/README.md)
    - [genann](examples/genann/README.md)
    - [lil](examples/lil/README.md)
    - [xzoom](examples/xzoom/README.md)
    <!-- - [robotfindskitten](examples/robotfindskitten/README.md) -->
- [For Developers](docs/README-developers.md)
    - [Docker Setup](docker/README.md)
    - [Translator Testing](tests/README.md)
    - [Building the manual](docs/build_manual.md)
    - [Source walkthrough](docs/source_walkthrough.md)
